using System;

namespace bigloo
{
  public class procedure
  {
    public int index;     // use as entry point
    public int arity;
    public Object[] env;

    public static readonly nil _nil= nil._nil;

    public procedure()
    {
    }

    public procedure( int  arity,
                      int  index )
    {
      this.arity= arity;
      this.index= index;
      this.env= new Object[0];
    }

    public procedure( int       arity,
                      int       index,
                      Object[]  env )
    {
      this.arity= arity;
      this.index= index;
      this.env= env;
    }

    public procedure( int  arity,
                      int  index,
                      int  size )
    {
      this.arity= arity;
      this.index= index;
      this.env= new Object[size];
    }

    public virtual Object apply( Object  args )
    {
      foreign.Error( "Call generic apply " + GetType() + " " + index );
      return null;
    }

    public virtual Object funcall0()
    {
      return apply( _nil );
    }

    public virtual Object funcall1( Object  a1 )
    {
      return apply( pair.cons( a1, _nil ) );
    }

    public virtual Object funcall2( Object  a1,
                                    Object  a2 )
    {
      return apply( pair.cons( a1, pair.cons( a2, _nil ) ) );
    }

    public virtual Object funcall3( Object  a1,
                                    Object  a2,
                                    Object  a3 )
    {
      return apply( pair.cons( a1, pair.cons( a2, pair.cons( a3, _nil ) ) ) );
    }

    public virtual Object funcall4( Object  a1,
                                    Object  a2,
                                    Object  a3,
                                    Object  a4 )
    {
      return apply( pair.cons( a1, pair.cons( a2, pair.cons( a3, pair.cons( a4, _nil ) ) ) ) );
    }

    // !!!!! Les mthodes funcall_errorX n'existent pas en Java !!!!
    public Object funcall_error0()
    {
      return null;
    }

    public Object funcall_error1( Object  a1 )
    {
      return null;
    }

    public Object funcall_error2( Object  a1,
                                  Object  a2 )
    {
      return null;
    }

    public Object funcall_error3( Object  a1,
                                  Object  a2,
                                  Object  a3 )
    {
      return null;
    }

    public Object funcall_error4( Object  a1,
                                  Object  a2,
                                  Object  a3,
                                  Object  a4 )
    {
      return null;
    }

    // !!!!! Cette mthode n'existe pas en Java !!!!!
    public Object apply_error( Object  l )
    {
      return null;
    }

    public void write( output_port  p )
    {
      p.write( "#<procedure:" );
      p.write( arity );
      p.write( ">" );
    }
  }
}
